/*
 * blackcore networking
 * source@source.blackcore.net
 * gcc getaddr.c -o getaddr -O2 -Wall
 *
 * ./getaddr <interface>
*/
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <linux/if.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <arpa/inet.h>
int main(int argc, char *argv[]) {
	int s;
	struct ifreq ifr;
	if (argc < 2) {
		printf("usage: %s <interface>\n", argv[0]);
		return 3;
	}
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		return 1;
	}
	strncpy(ifr.ifr_name, argv[1], sizeof(ifr.ifr_name));
	if (ioctl(s, SIOCGIFADDR, &ifr) < 0) {
		perror("ioctl");
		return 2;
	}
	printf("%s\n", inet_ntoa((struct in_addr)(((struct sockaddr_in *)&ifr.ifr_ifru.ifru_addr)->sin_addr)));
	close(s);
	return 0;
}
